local _, addon = ...

-- functions
local print, select, tostring, type = print, select, tostring, type
local format = string.format
-- constants
-- frames
-- libs

function addon:Print(...)
    local obj
    for i = 1, #... do
        obj = select(i, ...)
        if obj and type(obj) == "table" then
            print(format("|cff%sBK:|r", "6699CC"))
            DevTools_Dump(obj)
        elseif obj then
            print(format("|cff%sBK:|r %s", "6699CC", type(obj) == "string" and format(obj, ...) or tostring(obj)))
        end
    end
end

function addon:Debug(...)
    if not ... or not self.options or self.options.debug ~= true then return end

    return self:Print(...)
end

function addon:Initialise(db)
    self:Debug("Initialising.")

    self.db = db

    self.db.characters = self.db.characters or {}
    -- migrate old "pools" system into new db format
    if self.db.pools ~= nil then
        if self.db.pools.player ~= nil then
            self.db.characters = self.db.pools.player
            self.db.pools.player = nil
        end
        self.db.pools = nil
    end

    local key = self:GetCharacterKey()
    self.db.characters[key] = self.db.characters[key] or self:GetPlayerInfo()

    self.player = self.db.characters[key]

    self:Fire(self.EVENT_CORE_INITIALISED)
end

addon:RegisterCallback(addon.EVENT_INITIALISED, function()
    addon:Debug("Ready.")
end)
